# Release Notes

## [Noch nicht veröffentlicht]

- derzeit keine Änderungen

## [Version 5.0.2] - 2022-03-09

- Bei der Auswahl von "Informationen zu einer Datenidentifikation" im Telnet-Interface wurde ein Fehler bei der Aspektauswahl korrigiert.

- Bei ungültigen Pfaden und Cron-Strings innerhalb von Property-Dateien des neuen datenkonsistenten Backups wird nun der Fehler behandelt und eine sinnvolle Fehlermeldung im Debug auszugeben. Zusätzliche Leerzeichen am Anfang und Ende werden nun ignoriert.

- Einige Debug-Ausgaben der Konsistenzprüfung wurden inhaltlich korrrigert.

- [Fehler 29](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/29): Das Archivsystem archiviert nun auch nachgelieferte leere Datensätze (z. B. "Keine Daten").

- Die SWE kann nun auch mit Java 17 kompiliert werden, dazu wurde die Gradle-Version auf 7 erhöht.

## [Version 5.0.1] - 2020-08-11

- [Fehler 28](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/28): Der Code zur Synchronisation auf die Datenidentifikationen wurde so überarbeitet, dass beim Verlassen der Datenidentifikation alle zugehörigen Indexdateien vom Archivsystem geschlossen werden.

- Dokumentation und Vereinfachung des Codes.

- Ausgabe beim Schließen der Indexe korrigiert und das Schließen der Indexe beschleunigt.

## [Version 5.0.0] - 2020-05-13

### Neue Features

- [Fehler 26](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/26): Das Archivsystem erlaubt nun, datenkonsistente Spiegelungen/Backups des Persistenzverzeichnisses im laufenden Betrieb anzulegen, eine Kurzanleitung ist in der Datei *Konsistentes Backup.md* in diesem Repository vorhanden.

### Änderungen

- Eine NullPointerException, die in Version 4.7.0 beim Zugriff auf DatenIndex-Minimum-Werte beim Wiederherstellen eines Verwaltungsdatenindex mit fehlenden Containerdateien auftreten konnte, wurde korrigiert.

- Archivanfragen blockieren nun nicht mehr die Archivierung von Daten, falls der Client die Daten nicht schnell genug abruft.

- Umstellung von Code von `java.io` auf `java.nio`.

- Kompatibilität mit Windows-Dateisystemen verbessert.

- [Fehler 25](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/25): Als Workaround für das Problem, dass teilweise nachgeforderte Daten mehrfach archiviert werden, wird die Zahl der Nachforderungsthreads auf 1 begrenzt und nach jedem Nachforderungsschritt gewartet bis alle Daten archiviert sind. Eine bessere/performantere Lösung steht noch aus.

## [Version 4.7.0 Beta] - 2019-11-09

### Änderungen

- [Fehler 11](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/11): Über das neue Aufrufargument `-dynamischVorhalten=[ja/nein]` kann das Verhalten des Löschens beeinflusst werden. Ist `-dynamischVorhalten=ja` gesetzt, betrachtet das Archivsystem immer den aktuell parametrierten Vorhaltezeitraum (seit Abschluss der Containerdatei) um festzustellen, ob ein Container gelöscht werden kann. Das alte Verhalten entspricht `-dynamischVorhalten=nein` und berücksichtigt stattdessen den einmalig beim Abschluss den Containers eingetragenen Löschzeitpunkt, sodass sich eine nachträgliche Änderung der Parametrierung nicht auswirkt.

  Es ist möglich, den Parameter bei einem bestehenden Archiv beliebig in beide Richtungen zu ändern. Natürlich wirkt sich die Änderung des Aufrufparameters erst bei einem Neustart aus.
  
  Der Löschschutz wird durch diesen neuen Aufrufparameter nicht beeinflusst. Gegebenenfalls muss zusätzlich der Löschschutz ignoriert bzw. aufgehoben werden, um unerwünschte Daten löschen zu können. Das kann über einen manuellen Löschauftrag (*später Löschen* oder *sofort Löschen*) erfolgen.

- [Fehler 13](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/13): Der Code zum Nachfordern wurde überarbeitet. Das Nachfordern blockiert jetzt andere Tasks wie das Sichern oder Löschen nicht mehr, da nun nur während der Indizierung der Datenlücken das Containerverzeichnis exklusiv gesperrt wird, aber nicht während des langwierigen Nachforderungsprozesses.

- [Fehler 16](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/16): Die irreführende Debug-Meldung „*Temporaere Lueckendatei _datagaps.txt.tmp konnte nicht angelegt werden: Datei oder Verzeichnis nicht gefunden*“ wird nun nicht mehr ausgegeben.

- Die Wiederherstellung erkennt überflüssige defekte Containerdateien jetzt auch, wenn diese noch nicht abgeschlossen sind. (Ergänzung zur Änderung in Version 4.6.0)

- Statt über das Aufrufargument `-konfigurationsVerantwortlicher=` lässt sich das Archiv-Datenverteilerobjekt nun über das Argument `-archiv=`*objekt-pid* festlegen. Das angegebene Objekt muss dann keine autarke Organisationseinheit sein, ein beliebiges Objekt vom Typ `typ.archiv` oder ein davon abgeleitetes Objekt reicht. Dadurch ist es möglich, mehrere Archivsysteme auf der selben AOE parallel (mit unterschiedlichen Parametern) gleichzeitig zu starten.

## [Version 4.6.0 Beta] - 2019-10-30

### Änderungen

- [Fehler 7](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/7): Datenzeitrücksprünge werden in Containern, die Onlinedaten enthalten, jetzt zugelassen (solange die minimale Datenzeit des Containers nicht unterschritten wird). Dies verhindert die Erzeugung einer großen Menge an Containerdateien wenn eine Applikation große Mengen an lückenhaften Daten produziert.

- [Fehler 19](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/19): Wenn ein Verwaltungsdatenindex übermäßig viele Einträge enthält, also in einem Ordner übermäßig viele Containerdateien vorhanden sind, wird jetzt eine Debug-Warnung ausgegeben, die auf das Problem hinweist.

- Das Vorgehen bei der Wiederherstellung wurde optimiert, wodurch das mehrfache Öffnen des Verwaltungsdatenindex vermieden werden kann und während der Wiederherstellung bessere Ausgaben erfolgen.

- Die Wiederherstellung erkennt jetzt überflüssige defekte Containerdateien, die als Folge von Fehlern in vorherigen Versionen angelegt wurden, und kann diese ignorieren.

- Die Telnet-Schnittstelle besitzt jetzt den neuen Befehl "Übergroße Containerverzeichnisse", mit dem übermäßig große Containerverzeichnisse ausgegeben werden können.

## [Version 4.5.0 Beta] - 2019-10-02

### Änderungen

- Die DVD-Backup-Implementierung wurde entfernt, siehe [Eintrag #22](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/22)

- [Fehler 23](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/23): Ein Problem, das Auftrat wenn das Archivsystem und die Kernsoftware unterschiedliche Versionen der Guava-Bibliothek verwenden, wurde behoben. Das Archivsystem braucht jetzt nur noch Guava 21.

- Die Synchronisierung auf die Datenidentifikation bei allen Aktionen, die Containerverzeichnisse bearbeiten, wurde verbessert, sodass sich die Threads nicht gegenseitig blockieren. Dadurch kann insbesondere die Performance der Wiederherstellung verbessert werden.

- [Fehler 24](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/24): Ein neuer Fehler in Version 4.4.0 Beta führte dazu, dass in Aktionen, die Indexdateien betrafen und die längere Zeit brauchten, Probleme auftreten konnten, da die Indexdateien zu früh geschlossen wurden. Indexdateien werden jetzt erst dann geschlossen, wenn keiner mehr auf die Datenidentifikation zugreift.
 
- Ein neuer Fehler in Version 4.4.0 Beta führte dazu, dass die Synchronisierung auf Indexdateien nicht richtig funktionierte und dadurch in seltenen Fällen Fehlermeldungen bei der Wiederherstellung auftraten.

- Eine mögliche NullPointerException, die beim Beenden des Archivsystems während der Wiederherstellung auftreten konnte, wurde behoben. 

## [Version 4.4.0 Beta]

### WICHTIG

Das Archiv BETA 4.4.0 ist gegen die DEVELOP-Version 3.14.0 des Kernsystems gebaut, bei der bereits die guava-lib in Version 27 verwendet wird. 
Mit der Verwendung mit Kernsystem < 3.14.0 wird die falsche guava-lib in der Version 21 aus dem aktuellen Kernsystem 3.13.0 verwendet.

Aktuell kann man das Problem dadurch umgehen, dass man die Lib in den Classpath beim Archiv einträgt. Nachfolgend ein Ausschnitt aus StartStopp mit dem entsprechenden Eintrag (Zeile 3 `<aufrufparameter wert=" -cp %lib%/de.bsvrz.ars.ars/lib/guava-27.1-jre.jar;%lib%/de.bsvrz.ars.ars/de.bsvrz.ars.ars-runtime.jar"/>`):

```xml
<inkarnation name="Archiv">
	<applikation name="%java%"/>
	<aufrufparameter wert=" -cp %lib%/de.bsvrz.ars.ars/lib/guava-27.1-jre.jar;%lib%/de.bsvrz.ars.ars/de.bsvrz.ars.ars-runtime.jar"/>
	<aufrufparameter wert=" %jvmArgs%"/>
	<aufrufparameter wert=" -Xmx3g"/>
	<aufrufparameter wert=" de.bsvrz.ars.ars.mgmt.ArchiveManager"/>
	<aufrufparameter wert=" -datenverteiler=%davHost1%:%davAppPort1%"/>
	<aufrufparameter wert=" -benutzer=%benutzer%"/>
	<aufrufparameter wert=" -authentifizierung=%authentifizierung%"/>
	<aufrufparameter wert=" -erlaubeHmacAuthentifizierung=nein"/>
	<aufrufparameter wert=" -verschluesselung=nein"/>
	<aufrufparameter wert=" -zweiteVerbindung=ja"/>
	<aufrufparameter wert=" -puffer=50000000:50000000:100000000"/>
	<aufrufparameter wert=" -kommandoPort=4242"/>
	<aufrufparameter wert=" -persistenzVerzeichnis=../../archiv/byswstestfeld"/>
	<aufrufparameter wert=" -backup=filesystem.properties"/>
	<aufrufparameter wert=" -cachePufferGroesse=5120"/>
	<aufrufparameter wert=" -debugFilePath=%debugFilePath%"/>
	<aufrufparameter wert=" -debugLevelStdErrText=%debugLevelStdErrText%"/>
	<aufrufparameter wert=" -debugLevelFileText=%debugLevelFileText%"/>
	<startart option="automatisch" neustart="ja" intervall=""/>
	<startbedingung vorgaenger="Parametrierung" warteart="ende" wartezeit="%wartezeitProzesseNachParam%"/>
	<standardAusgabe option="ignorieren" dateiname="stdoutAlle"/>
	<standardFehlerAusgabe option="ignorieren" dateiname="stderrAlle"/>
	<startFehlerverhalten option="ignorieren" wiederholungen="5"/>
	<stoppFehlerverhalten option="ignorieren" wiederholungen="5"/>
</inkarnation>
```


### Änderungen

- [Fehler 20](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/20): Der Speicherverbrauch beim Wiederherstellungslauf wurde reduziert.

- [Fehler 20](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/20): Die Klasse `DataIdentNode` wurde überarbeitet und enthält nur noch die aktuelle Parametrierung sowie wenige globale Informationen. Folgende Informationen wurden in eigene Klassen ausgelagert:

  - Index-Cache
  - Synchronisierung
  - Informationen über offenen Container
  
- Löschzeitverlängern mit relativen Intervallangaben führt nun zu einem definierten Fehler, da dies nicht unterstützt wird.

- Der Code zum Wiederherstellen von fehlerhaften oder defekten Indexdateien wurde vereinfacht und beschleunigt. Zuerst wird nun (falls erforderlich) der Verwaltungsdatenindex aus den Containerheadern erzeugt, danach werden (falls erforderlich) aus dem Verwaltungsdatenindex und den Informationen im offenen Container die anderen Indexe gebildet.

- Indexe können nun im laufenden Betrieb geschlossen und wieder geöffnet werden, um Speicherplatz zu sparen.

- Die Anzahl der maximal gleichzeitig offenen Indexe kann nun mit dem Aufrufargument `-maxIndexCacheAnzahl=1000` vorgegeben werden (Standardwert 1000).

- Die maximale Größe des RAM-Puffers in Byte je Index kann nun mit `-maxIndexBytes=16384`  vorgegeben werden.

- (Teil-)Archivanfragen mit ungültigen Zeitbereichen (Obergrenze kleiner als Untergrenze) liefern nun konsistent eine leere Antwort zurück, statt unter gewissen Umständen Fehlermeldungen zu erzeugen.

- Das Archivsystem gibt nun in den regelmäßigen Ausgaben Statistiken über die Speicherbelegung aus.

- Ein Problem wurde korrigiert, bei dem ein Task, der Archivanfragen abarbeitet, das Lock auf seine Datenidentifikation nicht freigegeben hat und andere Tasks dadurch blockiert wurden.

- Die Telnet-Ausgabe zur Information über den `DataIdentTree` gibt nun korrekte Prozentwerte zurück.

- Beim endgültigen Löschen wurden nicht immer alle Index-Einträge gelöscht.

## [Version 4.3.0]   

- Defekte Containerdateien werden nun beim Wiederherstellungslauf und beim Update der 
  Datenstrukturen auf das neue Format zuverlässiger erkannt. 
  Durch das neue Aufrufargument 
  `-defekteDateienVerschieben=[nein|ja]`
  kann das Archivsystem angewiesen werden, defekte Dateien zu ignorieren und umzubenennen. 
  Damit kann das Archivsystem nun auch gestartet werden, wenn einige Dateien defekt 
  sind, und man muss diese nicht manuell löschen.
 
  Wird der Parameter nicht angegeben, wird automatisch der Defaultwert "nein" verwendet.
  Wird der Aufrufparamter ohne Wert angegeben (`-defekteDateienVerschieben`) wird der Wert "ja" gesetzt.
 
- Die Korrektur von defekten Containerdateien (Nerz-Ä-79) erkennt nun auch zu kurze 
  Containerdateien ohne oder mit unvollständigem Header und sorgt dafür, dass diese ignoriert werden.
  
- Die Korrektur von Containerdateien erkennt nun Container mit Datenzeitstempel-Werten von 0 (=1. Jan 1970) nicht mehr als fehlerhaft, da solche Daten wirklich schon archiviert wurden.
   
- [Fehler 8](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/issues/8): Eine Archivinformationsanfrage mit einem Anfragebereich, in dem keine Daten ermittelbar sind, resultierte in einem Ergebnis von Zeitstempel -1 bis -1 (1.1.1970 bis 1.1.1970) und Markierung "Keine Lücke". Dieser Datensatz wird nun nicht mehr gesendet.
 
- Die minütlichen Debug-Ausgaben über die Queue-Größen und Anzahl empfangener Datensätze werden nun wieder (wie bei Version 3.x) am Anfang jeder Minute publiziert, statt willkürlich ungefähr alle 60 Sekunden. Da viele Verkehrswerte ebenfalls minütlich erzeugt werden, ist dadurch eine bessere Vergleichbarkeit der Werte gegeben.

- Bei der Migration von verkürzten Containerdateien in die neue `_deleted.dat`-Datei (siehe Update-Hinweise zu 4.0.0 Beta) wurde ein Datei-Handle nach Benutzung nicht korrekt geschlossen, was zu "Too many open files"-Fehlern führen konnte. 

- Der Nachfordern-Task blockiert, während er läuft, jetzt keine gleichzeitigen lesenden Zugriffe auf die Containerdateien mehr, sodass sich Archivanfragen und Nachforderungen nicht mehr gegenseitig behindern.

- Tippfehlerkorrektur in Debug-Ausgaben.
   
## [Version 4.2.0 Beta]   
   
- Die Performance der Methode `ContainerFileHandle.getCreatePersDir` wurde verbessert, die Performance des Archivierens kann dadurch um ungefähr den Faktor 2 gesteigert werden.

## [Version 4.1.0 Beta]

### Änderungen

- Die Klasse `DataIteratorAdapter` wurde eliminiert und die Iteration im ContainerFile in eigene Klassen ausgelagert, wodurch der Code modularer und weniger fehleranfällig ist. Es wird nun ein getrennter Puffer zum Lesen der Header und Daten eines Containers verwendet.

- Eine IllegalArgumentException, die beim Aufruf der ContainerRescue-Applikation mit rekursivem Verzeichnisdurchlauf auftrat, wurde korrigiert. 

- Bei der geschätzten Fortschritts-Ausgabe von verschiedenen Tasks wurden kleinere Grammatikfehler korrigiert und die Ausgabe in bestimmten Fällen klarer gemacht.

- Die ContainerRescue-Applikation wurde optimiert und unterstützt nun Debug-Aufrufparameter wie `-debugLevelStdErrText=INFO`, womit eine detaillierte Ausgabe erzeugt werden kann.

- Der ContainerDirWalk wurde optimiert.

- Das Start des Archiv-Systems wurde optimiert, indem bei der Initialisierung der Indexe der neue Verwaltungsdatenindex benutzt wird, statt alle Containerdateien aufzulisten.

- Das Beenden des Archivs hebt nun die Blockierung von verschiedenen Tasks wegen Überlastung auf, wodurch unnötige Verzögerungen beim Beenden vermieden werden können.

- Die Queue-Größe wird nun auch periodisch ausgegeben, während das Archivsystem beendet wird, um abschätzen zu können, wie lange das Beenden noch dauert.

- NFM-55 Nachtrag: Die Implementierung der Sicherung wurde überarbeitet:

  - Die BackupIndex-Implementierung wurde entfernt und zur Indizierung der zu sichernden Dateien wird nun der Verwaltungsdatenindex benutzt
  
  - Bei der Indizierung der zu sichernden Containerdateien wird nun eine Fortschrittsanzeige über Debug ausgegeben.
  
  - Die Containerdateien im Persistenzverzeichnis werden nun erst auf gesichert gesetzt, wenn das Medium erfolgreich abgeschlossen wurde
  
  - Das Interface für die Backup-Module wurde geändert, um beim Kopieren der Containerdateien auf das Medium automatisch die Medien-ID im gesicherten Container zu vermerken.
    Alte Backup-Implementierungen werden durch eine Kompatibilitätsschicht weiterhin unterstützt, aber ohne optimale Performance. 
    
    Um eine Backup-Implementierung auf die neuen Klassen umzustellen sind zwei Interfaces zu implementieren:

    `BackupModule` muss implementiert werden und wird wie das bisherige `BackupModul` (ohne e am Ende) in der Properties-Datei angegeben. Diese Klasse enthält eine Factory-Methode um einer Instanz der `BackupImplementation` zu erzeugen:
    
    Das Interface `BackupImplementation` entspricht von den enthaltenen Methoden größtenteils dem bisherigen `BackupModul`-Interface, es gibt aber folgende Änderungen:
    
     *  Die Methode `backupContainer` erhält jetzt statt der Container-ID und dem Dateinamen einen Parameter der Klasse `Container`, mit dem Informationen über den Container (und ein InputStream für die Datei-Inhalte) abgerufen werden können. Sie gibt außerdem einen boolean zurück, der bei der Rückgabe von false signalisiert, dass der Container nicht mehr auf das aktuelle Medium gepasst hat.
     
     *  Die Methode `hasMediumCapacity` wird aufgrund dieses Rückgabewerts nicht mehr benötigt und entfällt.
     
     *  Die Methode `getAllContFileNames` verliert den letzten Parameter `maxLimit`, da dieser nicht benötigt wird.

## [Version 4.0.0 Beta]

### Update-Hinweise

Dieses Update ändert die Art, wie gelöschte Container im Dateisystem gespeichert werden. Sobald das Archivsystem auf diese Version oder eine höhere aktualisiert wurde, ist es nicht mehr möglich, eine frühere Version zu installieren und mit dieser gelöschte Daten wiederherzustellen oder anders auf diese zuzugreifen.

Da neue Index-Dateien angelegt werden, kann es beim ersten Start nach dem Update oder beim ersten Reparatur-Wiederherstellungslauf im Persistenzverzeichnis nach dem Update zu einer Performance-Verringerung gegenüber
dem normalen Betrieb kommen.

### Änderungen

- Nerz-Ä-9: Der Zeitstempel des Ende-Archiv-Datensatzes ergibt sich nun nicht mehr aus dem Zeitstempel des letzten Datensatzes sondern ergibt sich nun aus dem Zeitstempel des folgenden Datensatzes (d. h. dem Gültigkeitsende des letzten Datensatzes) oder dem Ende des Anfrageintervalls, je nachdem was vorher ist. Der Ende-Archiv-Datensatz gibt damit an, wie lange ein Datensatz innerhalb des Anfrageintervalls noch gültig ist.

- Nerz-Ä-72 / Nerz-Ä-73: Das Archivsystem speichert alle relevanten Container-Verwaltungsinformationen (Container-Header) nun in einem eigenen Index ab, damit bei vielen Operationen
  wie Archivanfragen, Löschen, Nachfordern usw. nicht mehr alle Containerdateien einzeln geöffnet und analysiert werden müssen. Hierdurch wird die Performance wesentlich gesteigert,
  da wesentlich weniger Dateioperationen erforderlich sind. Vor allem der Lösch-Task kann nun ohne großen Aufwand ermitteln, welche Container zu löschen sind und wird dadurch wesentlich
  beschleunigt.
  
  Außerdem werden die Container-Dateien beim Löschen nun komplett gelöscht, statt die Datei nur auf die Container-Header zu verkürzen.
  
  Pro Containerverzeichnis gibt es nun folgende neue Dateien:
  
  - `_cthead.idx`: Enthält alle relevanten Container-Verwaltungsinformationen der Container in diesem Verzeichnis um den Zugriff wesentlich zu beschleunigen. Diese Datei wird (falls
    sie nicht vorhanden ist) automatisch beim ersten Zugriff aus den Containerdateien (und der `_deleted.dat`) in dem Verzeichnis neu gebildet.
  
  - `_deleted.dat`: Enthält alle weiteren Informationen, die für gelöschte Container relevant sind. Diese Datei ersetzt alle verkürzten Container-Dateien im Verzeichnis und
    wird beim ersten Zugriff automatisch aus diesen generiert. Außerdem enthält sie die bisher in den gelöschten Containern gespeicherten Datenindexbereiche, die beim Nachfordern ignoriert werden.
    Diese Datei darf (wie die verkürzten Container) nicht gelöscht werden, sonst gibt es möglicherweise Datenverlust beim Wiederherstellen und Probleme beim Nachfordern.
    
  - `_deleted.tmp`, `_deleted.backup`: Temporäre Kopien der `_deleted.dat`, mit denen sichergestellt wird, dass die Datei immer konsistent bleibt.
  
  Alle Tasks, die Container-Header lesen, wurden nun auf die Benutzung des Verwaltungsdatenindex umgestellt, außer der Task muss sowieso die gesamte Containerdatei lesen oder der Index ist nicht verfügbar.
  
  Alle Tasks, die Containerdaten lesen (im wesentlichen Archivanfragen und Informationsanfragen, aber auch Löschen und Nachfordern) wurden so geändert, dass das neue Format der gelöschten Daten
  berücksichtigt wird. Hierzu wurden die verschiedenen `ContainerWalk`-Methoden komplett überarbeitet und im wesentlichen durch eine einzelne Implementierung ersetzt, sodass doppelter Code reduziert wird.
  Dies entspricht einer Fortführung der Korrekturen zu Nerz-F-150, sodass Archivanfragen und Archivinformationsanfragen nun in wesentlichen Teilen den selben Code verwenden und daher nun auch
  übereinstimmende Ergebnisse liefern.
  
- Durch diese Änderungen wurden Einschränkungen bei der Verwendung von Relativanfragen eliminiert, d. h. diese sind nun z. B. auch auf Archivinformationsanfragen anwendbar. Ebenfalls sollte die Performance von Relativanfragen durch die Verwendung des Verwaltungsinformationen-Index nun wesentlich beschleunigt worden sein.   
  
- Nerz-Ä-76: Das Archivsystem besitzt nun die Möglichkeit, Archivdaten endgültig und inklusive Metadaten zu löschen. Endgültig gelöschte Daten sind nicht mehr von Sicherungsmedien wiederherstellbar und verbrauchen keinerlei Platz im Archivsystem.
  Die Parametrierung erfolgt über die Attributgruppe atg.archivDatenEndgültigLöschen am Archiv/AOE-Objekt. 
  
- Nerz-Ä-78: Die potentiellen Datenlücken, die vor dem ersten archivierten Datensatz nach einem Neustart angelegt werden, erhalten jetzt 
  als Datenzeitstempel nicht mehr den Zeitstempel des vorherigen Datensatzes sondern den letzten Zeitpunkt, den das Archivsystem den letzten Datensatz (vor dem Beenden) noch empfangen hatte.
  
  Hierzu werden die Zeitstempel in der neuen Datei `_restartTime.property` im Wurzelverzeichnis des Archivsystem gespeichert. Fehlt diese Datei (z. B. direkt nach dem Update) wird wie bisher das alte Verhalten benutzt.
  
- Nerz-Ä-79: Das Archivsystem prüft nun vor dem ersten schreibenden Zugriff (d. h. vor dem ersten Anhängen von Archivdaten an einen vorhandenen offenen Container), ob dieser mit den 3 Bytes "`##\n`"
  endet. Ist das nicht der Fall, dann wird die Containerdatei als defekt erkannt und eine Reparatur gestartet, d. h. alle Datensätze werden gelesen und alle überflüssigen Bytes nach dem letzten gültigen Datensatz werden verworfen.
  
  Ist durch das Verwerfen von defekten Daten eine Datenlücke entstanden wird hier (wie sonst auch) ein leerer Datensatz mit Markierung "potentielle Datenlücke" eingefügt. Ebenfalls werden die Indexdateien
  aktualisiert, damit die Informationen konsistent bleiben.   
  
- Der Arbeitsspeicher-Verbrauch der Klasse `DataIdentNode`, die je Datenidentifikationen die Indexe bereitstellt und weitere Informationen zwischenspeichert, wurde optimiert.

- Beim Schreiben des Caches beim Beenden wird nun jede Minute ein Fortschritt über die Debug-Ausgabe ausgegeben.

- Beim Beenden aufgrund eines schweren Fehlers (z. B. zu wenig freier Arbeitsspeicher) beendet sich das Archivsystem nun so schnell wie möglich. Nicht unbedingt notwendige langwierige Aufräumarbeiten wie das Leeren der Queues werden übersprungen, damit in jedem Fall zeitnah wichtige Aufräumarbeiten wie das Schreiben der Indexdateien durchgeführt werden können.

- Es können nun mit dem Aufrufparameter "-lzvThreads=<Anzahl>" eine Anzahl Threads für das Löschen und Löschzeitverlängern angegeben werden. Durch eine Erhöhung vom Standardwert 1 kann das Löschen (ggf. unter Erhöhung der Gesamtlast) beschleunigt werden.

- Die Performance des Wiederherstellungslaufs nach einem nicht ordnungsgemäßen Beenden wurde verbessert.

- Weitere Verbesserungen bei der Performance beim Löschen.

- Das Archiv gibt nun beim Wiederherstellungslauf und bei verschiedenen Löschoperationen einen detaillierten Fortschritt und eine Prognose über die verbleibende Zeit über die Debug-Ausgabe aus. 

### Bugfixes

- Nerz-F-55: Wenn das Abschließen eines Sicherungsmediums fehlschlägt wurden nur die Container als ungesichert markiert, die auf diesem Medium gesichert wurden wären. Container, die auf weiteren Medien gesichert worden wären, wurden nicht korrekt im Backup-Index aktualisiert.

- Nerz-F-168, Nerz-F-253: In den Implementierungen der Indexe gab es mehrere nicht betrachtete Randfälle und fehleranfällige Code-Stellen bei der binären Suche, die unter bestimmten 
  Bedingungen zu scheinbar zufälligen `ArrayIndexOutOfBoundsException`s und anderen Fehlern führen konnten. Die Implementierungen der Indexe verwenden nun die gemeinsame Basisklasse `AbstractIndex`, wurden grundlegend überarbeitet und durch neue Caching-Mechanismen optimiert.
  
  Insbesondere wurden folgende Probleme korrigiert:
  
  - Die Methode ATimeMonotoneIndex.binaryMemSearch() konnte in mehreren Situationen den Wert -1 zurückliefern. Unter Umständen wurde darauf nicht korrekt reagiert, was zu Exceptions führte, die mangels korrekter Behandlung dazu führten, dass der Index in einen undefinierten, fehlerhaften Zustand wechselte.
  
  - Die Methode DataIdentNode.getOpenContID() lieferte in manchen Situationen, z. B. nach dem Unterdrücken eines übergroßen Datensatzes oder nach einer Parameteränderung fehlerhafterweise den zuletzt geschlossenen Container als offenen Container zurück, was dazu führte, dass der Container ein zweites Mal abgeschlossen werden konnte, was zu doppelten Indexeinträgen führen konnte.
  
  - Ein Fehler in der Methode DataIndexIndex.getContainerID() konnte bei Archivanfragen falsche Ergebnisse liefern und dazu führen, dass falsche Daten nachgefordert werden, insbesondere auch solche, die bereits im Archiv enthalten sind.
  
  - Verschiedene weitere Inkonsistenzen in den Klassen DataTimeIndex und DataIndexIndex, die u. a. bei Datenindexrücksprüngen unter bestimmten Umständen zu fehlerhaften Indexeinträgen führen können. 
  
- Nerz-F-230: Das Archivsystem führt keine überflüssigen Archivanfragen mehr durch, wenn das Archiv, von dem nachgefordert werden soll, nicht erreichbar ist.
  Das Archivsystem führt beim Nachfordern intern eine Archivanfrage bei sich selbst durch um festzustellen, wo Datenlücken vorliegen. Dies wurde auch dann gemacht, wenn keines der Archive, von denen nachgefordert werden soll,
  erreichbar ist und konnte dann bei entsprechend umfangreicher Parametrierung zu hoher Last führen, insbesondere weil der Vorgang nicht durch die Übertragung von Daten und die Anfrage beim anderen Archiv ausgebremst wird.
  
  Das Archivsystem überspringt nun automatisch die Nachforderung, wenn keines der parametrierten bzw. in der Nachforderungsanfrage spezifizierten Archivsysteme erreichbar ist. Ebenfalls wird die Eintragung der Information in die Lückendatei, dass
  das andere Archivsystem die Daten nicht gespeichert hat, nur noch dann vorgenommen, wenn das andere Archivsystem wirklich erreichbar war. Dadurch wird bei der automatischen Nachforderung die Nachforderung dann nachgeholt, wenn
  das andere Archiv wieder online ist. Bisher wurde in so einem Fall angenommen, dass die Daten dort generell nicht verfügbar sind.

- Beim Mischen von Online-Daten und nachgelieferten Daten in Archivanfragen werden gemäß den Technischen Anforderungen nachgelieferte Datensätze nur noch zur Bestimmung des Anfangszustands eliminiert, d. h.
  falls diese vor dem Anfragezeitraum liegen. In bisherigen Versionen wurden unnötigerweise alle nachgelieferten Daten vor dem ersten aktuellen Datensatz eliminiert, selbst
  wenn diese im Anfragebereich lagen. Die Software kann daher jetzt nachgelieferte Datensätze als initiale Datensätze verschicken, sofern das nicht der geforderten Sortierung der Daten
  widersprechen würde.

## [Version 3.10.0 Beta 2]

### Änderungen

- Die neue Version des Archivsystems benötigt als zusätzliche Abhängigkeit die Kernsoftware in Mindestversion 3.9.6. Die Archiv-Fehler Nerz-F-44 und Nerz-F-141 wurden in dieser Kernsoftwareversion korrigiert.

- Nerz-Ä-8: Die Anzahl der gleichzeitig geöffneten Container-Dateien beim Lesen von Archivdaten wird auf standardmäßig 500 begrenzt 
  um Limits des Betriebssystems zu umgehen. Hierzu wurde eine Zugriffsschicht implementiert, die beim Überschreiten des Grenzwertes die 
  älteste geöffnete Containerdatei schließt.
  Bei Bedarf lässt sich mit den neuen Aufrufargument `-maxOffeneDateien=500` ein anderer Grenzwert vorgeben.

- Nerz-Ä-10: Das Archivsystem veröffentlicht jetzt den verfügbaren Speicherplatz im Persistenzverzeichnis am Archiv-Objekt unter der Attributgruppe `atg.archivSpeicherplatz`. 

- Nerz-F-49: Beendet sich das Archivsystem aufgrund eines Fehlers, wird nun über die Debug-Ausgabe ein Thread-Dump ausgegeben, um Fehler besser diagnostizieren zu können.
  
- Nerz-F-55: Die Implementierung des Backup-Indexes wurde angepasst, sodass das Einfügen von doppelten Container-IDs im Code mit einer Fehlermeldung verhindert wird.
  
- Nerz-F-91: Folgende zusätzliche Hintergrund-Tasks werden beim Beenden des Archivsystems nun zeitnah beendet (ohne Datenverlust):

  - Sichern
  - Archivanfragen
  - Archiv-Informations-Anfragen
  
  Beim Sichern wird das aktuelle Medium mit den ggf. bereits gesicherten Daten abgeschlossen, weitere zu sichernde Daten werden dann erst 
  beim nächsten Sicherungslauf gesichert. Die Archivanfragen werden abgebrochen, sodass der Anwender beim Abruf eine entsprechende Fehlermeldung erhält.
  
- Nerz-Ä-66: Die Anzahl der Threads zur Archivierung für Online-Datensätze kann nun mit dem Aufrufargument `-archivierungsThreads=` angegeben werden.
  Der Standardwert wurde von 61 auf 11 geändert. Die Anzahl Threads zur Archivierung von nachgeforderten Datensätzen lässt sich mit 
  `-nachforderungsThreads=` beeinflussen. Der Standardwert hierfür ist jetzt 3 statt vorher 8.
  
  Zusätzlich kann nun die von allen Threads geteilte Puffergröße durch ein Aufrufargument angepasst werden. Frühere Archivsystem-Versionen besaßen 
  eine feste Gesamtgröße von 183.000 für Onlinedaten und eine Gesamtgröße von 16.000 für nachgeforderte Daten.
  Die Puffergröße kann nun durch die folgenden Aufrufargumente angepasst werden (mit neuen Standardwerten):
  
    -archivierungsPuffer=200000
    -nachforderungsPuffer=20000
    
  Mit einer größeren Puffergröße kann (zusammen mit den Änderungen aus Nerz-Ä-75) das Terminieren der Verbindung wegen zu geringem Durchsatz
  während Lastspitzen vermieden werden.

- Nerz-Ä-68: Das Schreiben der Indexdateien beim Beenden erfolgt nun in mehreren Threads gleichzeitig. Die Threadanzahl entspricht standardmäßig 
  der Anzahl Threads für die Online-Archivierung (Aufrufargument `-archivierungsThreads=11` aus Nerz-Ä-66), kann jedoch mit dem Aufrufargument 
  `-indexUpdateThreads=` überschrieben werden. Es erfolgt nun alle 10 Sekunden eine Debug-Ausgabe über den Fortschritt.

- Nerz-Ä-69: Die manuelle Konsistenzprüfung erfolgt nun in mehreren Threads gleichzeitig. Die Threadanzahl beträgt standardmäßig der Anzahl 
  Threads für die Online-Archivierung (Aufrufargument `-archivierungsThreads=11` aus Nerz-Ä-66), kann jedoch mit dem Aufrufargument 
  `-pruefThreads=` überschrieben werden. Es erfolgt nun alle 10 Sekunden eine Debug-Ausgabe über den Fortschritt.

- Nerz-Ä-70: Das Sichern von Containern wurde durch Verwendung eines `BufferedInputStream`s und einer größeren Puffergröße von 8 kB optimiert.

- Nerz-Ä-75: Die Anmeldungen von Daten nach dem Start des Archivsystems oder bei einer Parameteränderung werden nun automatisch gedrosselt, 
  um eine Überlastung des Systems zu vermeiden. Hierzu wurde ein Sliding-Window-Mechanismus implementiert, der die Anzahl noch nicht quittierter
  Anmeldungen beschränkt und weitere Anmeldungen erst dann zulässt, wenn schon durchgeführte Anmeldungen (durch den initialen Datensatz) quittiert werden.

  Bei Bedarf lässt sich der Mechanismus über folgende neue Aufrufparameter (Standardwerte sind angegeben) einstellen:
  
    -maxAnmeldungenGleichzeitig=1000
    -minAnmeldungenProSekunde=1
    -maxAnmeldungenProSekunde=<Unendlich>
    
  `maxAnmeldungenGleichzeitig` definiert die Größe des Sliding-Windows, also die maximale Anzahl gleichzeitig unbestätigter Anmeldungen. 
  Mit zum Beispiel `-maxAnmeldungenGleichzeitig=1` würde das Archivsystem immer nur eine Anmeldung gleichzeitig durchführen und dann warten
  bis diese bestätigt wurde, bevor die nächste Anmeldung durchgeführt wird. 
  
  Mit `minAnmeldungenProSekunde` lässt sich der Sliding-Window-Mechanismus beschleunigen, beispielsweise würde  `-minAnmeldungenProSekunde=2000` dafür sorgen,
  dass pro Sekunde 2000 Anmeldungen durchgeführt werden, selbst wenn es mehr als `maxAnmeldungenGleichzeitig` unbestätigte Anmeldungen gibt und
  die Anmeldung dadurch verzögert worden wäre.
  
  Mit `maxAnmeldungenProSekunde` lassen sich die Anmeldungen unabhängig vom Sliding-Window-Mechanismus verzögern. Beispielsweise würden mit 
  `-maxAnmeldungenProSekunde=10` maximal 10 Anmeldungen in der Sekunde durchgeführt werden, unabhängig von allen anderen Faktoren. Diese 
  Funktion ist dadurch implementiert, dass das Archivsystem zwischen den Anmeldungen eine definierte Zeit wartet.
  Die hierzu verwendete Funktion der virtuellen Maschine besitzt nur eine eingeschränkte Genauigkeit, die auch stark vom verwendeten Betriebssystem abhängt,
  wodurch unter Umständen eine weitere unbeabsichtigte Verzögerung der Anmeldungen entstehen kann, das Setzen von `-maxAnmeldungenProSekunde=100000`
  oder einem ähnlich hohen Wert führt daher wahrscheinlich zu einer unerwartet hohen Verzögerung und ist nicht empfehlenswert.
  Falls es Überlastungsprobleme gibt, ist in der Regel das Reduzieren von `maxAnmeldungenGleichzeitig` ausreichend, die anderen Parameter sollten daher nur
  in Ausnahmefällen benutzt werden.
  
- Nerz-Ä-79 (teilweise): Das ContainerRescue-Programm erkennt jetzt unvollständig geschriebene (in der Regel noch nicht abgeschlossene) Containerdateien und
  kann überflüssige Bytes am Ende sowie unvollständige Datensätze erkennen und entfernen.
  
### Bugfixes

Folgende Probleme vorhergehender Versionen wurden behoben:

- Nerz-F-2: Falls ein Container nicht gesichert werden konnte, weil die Datei nicht vorhanden ist, wird nun eine klare Fehlermeldung erzeugt und der Container
  zukünftig ignoriert (aus dem Index entfernt). In vorherigen Versionen kam es bei jedem Backup zu Fehlermeldungen, da der gelöschte Container im Index blieb. 

- Nerz-F-4: Ein Problem, bei dem während des spontanen Löschens im Lösch-Level 2 alle abgeschlossenen Container gelöscht wurden, wurde korrigiert.
  In vorigen Versionen wurden wegen fehlender `break;`-Statements in einem `switch`-Block schon in Lösch-Level 2 die Lösch-Verfahren aus Level 3 und 4 angewendet.
  Außerdem wurden im Lösch-Level 4 wegen eines fehlerhaften String-Vergleichs alle abgeschlossenen Container gelöscht, nicht wie spezifiziert alle bereits gesicherten.  

- Nerz-F-36: Die Queue-Füllstände für nachgeforderte Datensätze werden in den periodischen Debug-Ausgaben nun getrennt von den Online-Daten 
  aufgeführt und auch im Code besser voneinander unterschieden.
  
  Das Nachfordern von Daten führte wegen Fehlern bei der Verwendung von globalen Statistik-Variablen zu negativen Angaben der Queue-Größe in den Debug-Meldungen.

- Nerz-F-37 / Nerz-F-164: Das Archivsystem erstellt keine überflüssigen temporären Container-Dateien mehr, wenn Daten wiederhergestellt werden sollen. In alten Versionen
  konnte es zu Problemen kommen, wenn der Speicherort nicht beschreibbar war oder wenig freier Festplattenplatz zur Verfügung stand.

- Nerz-F-38: Das manuelle Löschen über die DAF-API-Funktionen war fehlerhaft implementiert. Das sofortige Löschen (deleteImmediately==true) bewirkte intern ein Anstoß der
  spontanen Löschfunktion, die bei ausreichend verfügbarem Speicherplatz keine Daten löscht. Das verzögerte Löschen (deleteImmediately==false) bewirkte stattdessen einen
  sofortigen Anstoß der regulären periodischen Löschfunktion, die in der Regel ebenfalls nichts gelöscht hat, da sie den Löschschutz betrachtet. 

- Nerz-F-90 / Nerz-F-193 / Nerz-F-205: Es ist nicht mehr möglich, das Archivsystem mehrfach zu beenden. Hierzu wurde die Synchronisierung beim Beenden überarbeitet.

- Nerz-F-101 / Nerz-F-188 / Nerz-F-189 / Nerz-F-203: Tasks, die vorzeitig terminiert wurden, führen nicht mehr zu einem Blockieren beim Beenden. Der Code wurde korrigiert, indem die 
  nicht korrekt implementierte Semaphore durch eine einfache Abfrage der Thread-Zustände ersetzt wurde.

  Zusätzlich wurde der Mechanismus zum Starten und Beenden der Tasks komplett überarbeitet. Es kann nun nicht mehr passieren, dass sich ein Task wegen einer
  unbehandelten Exception oder wegen eines Interrupts ohne Rückmeldung terminiert. Ein Fehler in einem Task führt bei einem schweren Fehler nun zum kontrollierten Beenden
  des Archivsystems. Andere Fehler führen zu einer Debug-Ausgabe und lassen den Task weiterlaufen.
  
  Es wurde ein UncaughtExceptionHandler implementiert, der auch außerhalb von Tasks dafür sorgt, dass unbehandelte schwerwiegende Fehler (z. B. `OutOfMemoryError`s) 
  zu einem sofortigen Beenden des Archivsystems führen. Andere unbehandelte Fehler führen zu einer Debug-Warnung.
  
- Nerz-F-150: Die Ergebnisse von Archiv-Informations-Anfragen wurden grundsätzlich überarbeitet, insbesondere wurden folgende Fehler korrigiert:

  - Es wurden immer Ergebnisse für alle Datenarten zurückgeliefert, unabhängig von den angefragten Datenarten
  
  - Es konnte zu Performanceproblemen kommen, wenn nicht alle Datenarten angefragt wurden.
  
  - Das Behandeln von Datenlücken und das Mischen der einzelnen Datenidentifikationen wurde überarbeitet und verhält sich jetzt analog zu den Archivanfragen.
  
  - Nachgelieferte Daten werden nun (bei entsprechender Anfrage) korrekt einsortiert und führen nicht mehr zu erkannten Datenlücken.
  
  - Das Archivierungs-Bit in den Datenindizes wurde bei Datenlücken nicht immer korrekt gesetzt.
  
- Nerz-F-156: Bei der Wiederherstellung von Containern wurde der Sekunden-Wert der Löschschutzverlängerung fälschlicherweise als Millisekunden interpretiert, wodurch der
  Löschschutz-Zeitraum von wiederhergestellten Containern um den Faktor 1000 zu klein war. Hierdurch wurden beim regulären Löschen häufig wiederhergestellte Container
  gelöscht, die laut Parametrierung eigentlich einen Löschschutz haben müssten.
  
  Bei Archivanfragen  und  Archiv-Info-Anfragen war außerdem der Standardwert der maximalen Löschschutzverlängerung in der Klasse `QueryTask` in Millisekunden 
  definiert, er wird aber aber als Sekundenwert interpretiert. Der um den Faktor 1000 zu hohe Wert führte dabei zu einem Überlauf bei der Verarbeitung als 32-bit-Wert. 

- Nerz-F-197: Das Archivsystem kann sich jetzt auch dann aus einer Überlastsituation befreien, bei der Archivanfragen angehalten wurden, wenn keine neuen Datensätze
  eintreffen. In älteren Versionen wurde die Prüfung, ob die Überlastsituation vorbei ist und die Bearbeitung der Anfragen fortgesetzt werden soll, nur beim Eintreffen
  eines neuen, nicht ignorierten, Archiv-Datensatzes vorgenommen. 

- Nerz-F-209: Die Applikations-Fertigmeldung des Archivsystems wird jetzt erst versendet, wenn zum ersten mal alle zu archivierenden Daten angemeldet wurden. Vorher
  wurde sie direkt beim Programmstart versendet. Archivanfragen können erst dann durchgeführt werden, wenn alle Daten angemeldet sind.

- Der Wiederherstellungsauftrag hat die vom Anwender übergebenen Minimum- und Maximum-Werte zur Angabe des Zeitbereichs immer als Archivzeitstempel interpretiert, auch
  wenn vom Anwender Datenindex- oder Datenzeitwerte übergeben wurden. Unter Umständen wurden dadurch nicht die gewünschten Container wiederhergestellt. 

- Das Archivsystem hat Archivanfragen sofort verworfen, wenn eine negative Sendesteuerung vor dem Senden der Antwort registriert wurde. Das konnte dazu führen, dass
  Archivanfragen nicht beantwortet wurden und Aufrufe der Methode ArchiveQueryResult.isRequestSuccessful() blockierten. Da die Sendesteuerung insbesondere bei der Kopplung von Datenverteilern verzögert eintreffen kann, wird
  nun auf die Sendesteuerung mit einem Timeout gewartet. Sollte eine bereits positiv quittierte Übertragung unterbrochen werden (durch eine negative Quittung), wird
  wie bisher die Übertragung der Antwort sofort abgebrochen.

- Beim Wiederherstellungslauf nach einem Archivsystemabsturz konnte es aufgrund eines ungünstig programmierten rekursiven Algorithmus zu einer StackOverflowException
  kommen, wenn im Persistenzverzeichnis viele Ordner ohne Archivdatenart-Unterordner ("oa", "on", "na", "nn") existieren. Eine solche Ordnerstruktur kann beispielsweise
  entstehen, wenn Daten nachgefordert werden sollen, die in beiden beteiligten Systemen noch nie archiviert wurden. Der Algorithmus in der Klasse ContainerFileDirIterator
  wurde in einen iterativen Algorithmus umgewandelt, wodurch der Fehler trotz ungünstiger Ordnerstruktur nicht mehr auftreten kann. Die betroffene Klasse wurde ebenfalls
  beim Backup, Löschen, Löschzeitverlängern, Archivdaten aus einer Sicherung Wiederherstellen und bei der Konsistenzprüfung verwendet, sodass es dort möglicherweise zu
  ähnlichen Exceptions kommen konnte.

## Version 3.9.0

### Neue Features

Folgende Erweiterungen gegenüber vorhergehenden Versionen wurden durchgeführt:

- Nerz-Ä-12: Begrenzung der Anzahl parallel zu verarbeitenden Archivanfragen seitens einer einzelnen Applikation.
  - Im Archivsystem kann die maximale Anzahl von gleichzeitig für eine Applikation
    bearbeiteten Archivanfragen über den Aufrufparameter `-maxAnfragenProApplikation`
    eingestellt werden. Defaultwert ist 5.
  - Über eine entsprechende Archivanfrage kann der aktuell eingestellte Wert zur
    Laufzeit seitens einer Applikation abfragt werden.

### Änderungen

Folgende Änderungen zu vorhergehenden Versionen wurden durchgeführt:

- Nerz-Ä-16: Performance-Verbesserungen bei der Verwendung von ByteArrays in den Datenverteiler-Applikationsfunktionen.
  Verwendung der neuen Methoden des Data-Interface zum Setzen von `byte[]`, `short[]`, `int[]` etc.

### Bugfixes

Folgende Probleme vorhergehender Versionen wurden behoben:

- Bei Archivanfragen mit relative Zeitangaben konnte es unter bestimmten Umständen passieren, dass das Archivsystem
  in einer Endlosschleife  hängen blieb.


[Noch nicht veröffentlicht]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/compare/v5.0.2...HEAD
[Version 5.0.2]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/compare/v5.0.1...v5.0.2
[Version 5.0.1]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/compare/v5.0.0...v5.0.1
[Version 5.0.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/compare/v4.7.0-BETA...v5.0.0
[Version 4.7.0 Beta]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/compare/v4.6.0-BETA...v4.7.0-BETA
[Version 4.6.0 Beta]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/compare/v4.5.0-BETA...v4.6.0-BETA
[Version 4.5.0 Beta]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/compare/v4.4.0-BETA...v4.5.0-BETA
[Version 4.4.0 Beta]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/compare/v4.3.0...v4.4.0-BETA
[Version 4.3.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/compare/v4.2.0-BETA...v4.3.0
[Version 4.2.0 Beta]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/compare/v4.1.0-BETA...v4.2.0-BETA
[Version 4.1.0 Beta]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/compare/v4.0.0-BETA...v4.1.0-BETA
[Version 4.0.0 Beta]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.ars.ars/compare/v3.9.0...v4.0.0-BETA
