/*
 *
 * Copyright 2018-2019 by Kappich Systemberatung, Aachen
 *
 * This file is part of de.bsvrz.ars.ars.
 *
 * de.bsvrz.ars.ars is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * de.bsvrz.ars.ars is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.ars.ars.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * Kappich Systemberatung
 * Martin-Luther-Straße 14
 * 52062 Aachen, Germany
 * phone: +49 241 4090 436
 * mail: <info@kappich.de>
 */

package de.bsvrz.ars.ars.persistence;

import de.bsvrz.sys.funclib.kappich.annotations.Nullable;

import java.util.Iterator;
import java.util.LinkedHashSet;

/**
 *
 *
 * @author Kappich Systemberatung
 */
public class CollectionUtilities {
	private CollectionUtilities() {
		throw new AssertionError();
	}

	/**
	 * Entfernt den ältestem Eintrag aus dem LinkedHashSet und gibt ihn zurück. Falls das Set leer ist wird es nicht verändert und null zurückgegeben.
	 * @param set Menge
	 * @return ältestes Element
	 */
	@Nullable
	public static <T> T removeOldest(final LinkedHashSet<T> set) {
		if(set.isEmpty()) return null;
		Iterator<T> iterator = set.iterator();
		T next = iterator.next();
		iterator.remove();
		return next;
	}
}
