/*
 *
 * Copyright 2017-2020 by Kappich Systemberatung, Aachen
 *
 * This file is part of de.bsvrz.ars.ars.
 *
 * de.bsvrz.ars.ars is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * de.bsvrz.ars.ars is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.ars.ars.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * Kappich Systemberatung
 * Martin-Luther-Straße 14
 * 52062 Aachen, Germany
 * phone: +49 241 4090 436
 * mail: <info@kappich.de>
 */

package de.bsvrz.ars.ars.persistence.walk;

import de.bsvrz.ars.ars.persistence.DataIdentificationDir;

/**
 * Funktionelles Interface für eine Aktion, die je Containerdateien-Verzeichnis durchgeführt werden soll
 *
 * @author Kappich Systemberatung
 */
@FunctionalInterface
public interface DataIdentificationDirAction {

	/**
	 * Führt die Aktion aus
	 * @param dataIdentificationDir Parameter
	 * @param walk
	 * @throws Exception Beliebige Exception, die zum Terminieren des Durchlaufs führt.
	 */
	void run(DataIdentificationDir dataIdentificationDir, DataIdentificationDirWalk walk) throws Exception;

}
